﻿/////////////////////////////////////////////////
/// control section
/////////////////////////////////////////////////

Ha.WebApp.Control = Ha.WebApp.Control || {};

Ha.WebApp.Control.Dataset = new Array();


Ha.WebApp.Control.GetWidgetBatteryData = function (module) {
    var ret = '';
    var sbl = Ha.WebApp.Utility.GetModulePropertyByName(module, "Status.Battery");
    if (sbl != null) {
        var blevel = sbl.Value;
        if (blevel > 80) blevel = 100;
        else if (blevel > 60) blevel = 80;
        else if (blevel > 40) blevel = 60;
        else if (blevel > 20) blevel = 40;
        else if (blevel > 10) blevel = 20;
        else if (blevel > 0) blevel = 10;
        //
        var batimagesrc = 'images/widgets/battery_level_' + blevel + '.png';
        var batvalue = sbl.Value + '%';

        ret = '<div style="margin:2px;height:28px;float:left"><div align="right" style="padding:4px;height:28px;text-align:bottom;width:100px;float:left"><img src="' + batimagesrc + '" alt="' + sbl.UpdateTime + '" height="22" align="middle" style="vertical-align:bottom" /></div><div align="left" style="width:60px;padding:4px;float:left;"><font style="line-height:28px;text-align:bottom;color:gray">' + batvalue + '</font></div></div>';
    }
    return ret;
}


Ha.WebApp.Control.GetWidgetDateTime = function (updatetime) {
    if (updatetime != null) {
        var d = new Date(updatetime);
        updatetime = Ha.WebApp.Utility.FormatDate(d) + '<br>' + Ha.WebApp.Utility.FormatDateTime(d);
    }
    else
        updatetime = '';
    return updatetime;
}

Ha.WebApp.Control.GetWidgetUIData = function (module) {
    var data = {
        icon: '',
        //propertyname: '',
        status: '',
        timestamp: null,
        rawvalue: '',
        unit: ''
    };
    var value;

    if (module.DeviceType == 'S_GENERIC') {
        data.icon = 'images/widgets/sensor.png';
        var sdw = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.DoorWindow");

        if (module.Properties != null) {
            for (var p = 0; p < module.Properties.length; p++) {
                data.status = data.status + ((module.Properties[p].Description == '')?module.Properties[p].Name:module.Properties[p].Description) + ': ' + module.Properties[p].Value + ((module.Properties[p].Unit=='')?'':'&nbsp;'+module.Properties[p].Unit)+'<br>';
            }
        }

    }
    else if (module.DeviceType == 'S_DOOR') {
        data.icon = 'images/widgets/door_closed.png';
        var sdw = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.DoorWindow");
        if (sdw != null) {
            data.timestamp = sdw.UpdateTime;
            data.rawvalue = sdw.Value;
            if (sdw.Value == '1') {
                data.status = 'OPEN';
                data.icon = 'images/widgets/door_open.png';
            }
            else {
                data.status = 'CLOSE';
                data.icon = 'images/widgets/door_closed.png';
            }
        }
    }
    else if (module.DeviceType == 'S_LEAK') {
        data.icon = 'images/widgets/leak_ok.png';
        var sdw = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.Leak");
        if (sdw != null) {
            data.timestamp = sdw.UpdateTime;
            data.rawvalue = sdw.Value;
            if (sdw.Value == '1') {
                data.status = 'Leak';
                data.icon = 'images/widgets/leak_alarm.png';
            }
            else {
                data.status = 'Ok';
                data.icon = 'images/widgets/leak_ok.png';
            }
        }
    }
    else if (module.DeviceType == 'S_MOTION') {
        data.icon = 'images/widgets/motion.png';
        var sdw = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.Motion");
        if (sdw != null) {
            data.timestamp = sdw.UpdateTime;
            data.rawvalue = sdw.Value;
            if (sdw.Value == '1') {
                data.status = 'Motion';
                data.icon = 'images/widgets/motion_alarm.png';
            }
            else {
                data.status = 'Ok';
                data.icon = 'images/widgets/motion.png';
            }
        }
    }
    else if ((module.DeviceType == 'S_TEMP') || (module.DeviceType == 'S_TEMP_AO')) {
        data.icon = 'images/widgets/temperature.png';
        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.Temperature");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit=='')?'':'&nbsp;'+stemp.Unit); //'&#8451;';
            data.unit = stemp.Unit;
        }
    } 
    else if ((module.DeviceType == 'S_HUM') || (module.DeviceType == 'S_HUM_AO')) {
        data.icon = 'images/widgets/humidity.png';
        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.Humidity");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit=='')?'':'&nbsp;'+stemp.Unit); //+ '%';
            data.unit = stemp.Unit;
        }
    }
    else if (module.DeviceType == 'S_LIGHT_LEVEL') {
        data.icon = 'images/widgets/radiation.png';
        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.LightLevel");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit == '') ? '' : '&nbsp;' + stemp.Unit); //+ '%';
            data.unit = stemp.Unit;
        }
    }
    else if (module.DeviceType == 'S_ANALOG_INPUT') {
        data.icon = 'images/widgets/ai.png';
        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.AnalogValue");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit=='')?'':'&nbsp;'+stemp.Unit); //
            data.unit = stemp.Unit;
        }
    }
    else if (module.DeviceType == 'S_BARO') {
        data.icon = 'images/widgets/pressure.png';

        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.Pressure");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit=='')?'':'&nbsp;'+stemp.Unit); //
            data.unit = stemp.Unit;
        }
        stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.Forecast");

        if (stemp != null) {
            //data.timestamp = stemp.UpdateTime;

            if (data.status != '')
                data.status += '<br>';
            data.status += stemp.Value;
        }
    }
    else if (module.DeviceType == 'S_DISTANCE') {
        data.icon = 'images/widgets/distance.png';
        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.Distance");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit == '') ? '' : '&nbsp;' + stemp.Unit); //
            data.unit = stemp.Unit;
        }
    }
    else if (module.DeviceType == 'S_DUST') {
        data.icon = 'images/widgets/dust.png';
        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.DustLevel");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit == '') ? '' : '&nbsp;' + stemp.Unit); //
            data.unit = stemp.Unit;
        }
    }
    else if (module.DeviceType == 'S_POWER') {
        data.icon = 'images/widgets/power.png';
        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.Power");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit == '') ? '' : '&nbsp;' + stemp.Unit); //
            data.unit = stemp.Unit;
        }

        stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.PowerPerTime");

        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;

            if (data.status != '')
                data.status += '<br>';
            data.status += value + ((stemp.Unit == '') ? '' : '&nbsp;' + stemp.Unit);
            data.unit = stemp.Unit;
        }
    }
    else if (module.DeviceType == 'S_WATER') {
        data.icon = 'images/widgets/water.png';

        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.WaterFlow");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit == '') ? '' : '&nbsp;' + stemp.Unit); //
            data.unit = stemp.Unit;
        }
        stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.WaterVolume");

        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;

            if (data.status != '')
                data.status += '<br>';
            data.status += value + ((stemp.Unit == '') ? '' : '&nbsp;' + stemp.Unit);
            data.unit = stemp.Unit;
        }
    }
    else if (module.DeviceType == 'S_UV') {
        data.icon = 'images/widgets/uvindex.png';
        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.UVIndex");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit == '') ? '' : '&nbsp;' + stemp.Unit); //
            data.unit = stemp.Unit;
        }
    }
    else if (module.DeviceType == 'S_DIGITAL_INPUT') {
        data.icon = 'images/widgets/digital_input.png';
        var sdw = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.DigitalValue");
        if (sdw != null) {
            data.timestamp = sdw.UpdateTime;
            data.rawvalue = sdw.Value;

            if (sdw.Value == '1') {
                data.status = 'ON';
                //data.icon = 'images/widgets/door_open.png';
            }
            else {
                data.status = 'OFF';
                //data.icon = 'images/widgets/door_closed.png';
            }
        }
    }
    //    else if (module.DeviceType == 'S_LIGHT') {
    //        var level = Ha.WebApp.Utility.GetModulePropertyByName(module, "Status.Level");
    //        if (level != null) {
    //            level = Ha.WebApp.Utility.GetModulePropertyByName(module, "Actuator.DigitalOutput");
    //            if (level != null)
    //                level *= 100;
    //        }

    //        data.icon = 'images/widgets/socket_off.png';
    //        // level
    //        if (level != null) {
    //            data.timestamp = level.UpdateTime;

    //            value = Math.round(level.Value.replace(',', '.') * 100) / 100;
    //            if (isNaN(value)) value = level.Value;

    //            data.status = (value >= 99 ? 'ON' : 'OFF');

    //            if (data.status == 'OFF') {
    //                data.icon = 'images/widgets/socket_off.png';
    //            }
    //            else {
    //                data.icon = 'images/widgets/socket_on.png';
    //            }
    //        }
    //    }
    else if (module.DeviceType == 'S_DIGITAL_OUTPUT') {
        data.icon = 'images/widgets/socket_off.png';

        var level = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.DigitalValue");
        // level
        if (level != null) {
            data.timestamp = level.UpdateTime;
            data.rawvalue = level.Value;

            value = Math.round(level.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = level.Value;

            data.status = (value >= 1 ? 'ON' : 'OFF');

            if (data.status == 'OFF') {
                data.icon = 'images/widgets/socket_off.png';
            }
            else {
                data.icon = 'images/widgets/socket_on.png';
            }
        }
    }


    else if (module.DeviceType == 'S_ANALOG_OUTPUT') {
        data.icon = 'images/widgets/ao.png';

        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.AnalogValue");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit=='')?'':'&nbsp;'+stemp.Unit); //
            data.unit = stemp.Unit;
        }
    }

    else if (module.DeviceType == 'S_DIMMER') {
        data.icon = 'images/widgets/dimmer.png';

        var stemp = Ha.WebApp.Utility.GetModulePropertyByName(module, "Sensor.DimmerLevel");
        // Status senzorja
        if (stemp != null) {
            data.timestamp = stemp.UpdateTime;
            data.rawvalue = stemp.Value;

            value = Math.round(stemp.Value.replace(',', '.') * 100) / 100;
            if (isNaN(value)) value = stemp.Value;
            data.status = value + ((stemp.Unit=='')?'':'&nbsp;'+stemp.Unit);
            data.unit = stemp.Unit;
        }
    }


    return data;
}


Ha.WebApp.Control.UpdateModuleWidgetKnobValue = function (controlpopup, module1) {
    var o4;
    if (module1.DeviceType == 'S_ANALOG_OUTPUT')
        o4 = Ha.WebApp.Utility.GetModulePropertyByName(module1, "Sensor.AnalogValue");
    if (module1.DeviceType == 'S_HUM_AO')
        o4 = Ha.WebApp.Utility.GetModulePropertyByName(module1, "Sensor.Humidity");
    if (module1.DeviceType == 'S_TEMP_AO')
        o4 = Ha.WebApp.Utility.GetModulePropertyByName(module1, "Sensor.Temperature");
    if (module1.DeviceType == 'S_DIMMER')
        o4 = Ha.WebApp.Utility.GetModulePropertyByName(module1, "Sensor.DimmerLevel");

    if (o4 == null)
        knobValue = 0;
    else {
        knobValue = Math.round(o4.Value.replace(',', '.') * 100) / 100;
        if (isNaN(knobValue)) knobValue = o4.Value;
    }



    //if (knobValue != controlpopup.find('[data-ui-field=level_knob]').val())
    //controlpopup.find('[data-ui-field=level_knob]').val(knobValue).trigger('change');
    controlpopup.find('[data-ui-field=level_knob]').val(knobValue);

}



Ha.WebApp.Control.UpdateModuleWidget = function (domain, address) {
    var container;
    var data;
    var updatetime;
    var widget;
    // loop groups
    for (var i = 0; i < Ha.Data.Groups.length; i++) {
        group = Ha.Data.Groups[i];
        // loop modules in group
        for (var j = 0; j < group.Modules.length; j++) {
            var module = group.Modules[j];
            // check if module is in group
            if ((module.Domain == domain) && (module.Address == address)) {
                module = group.Modules[j];
                // find module
                for (var k = 0; k < Ha.Data.Modules.length; k++) {
                    if ((Ha.Data.Modules[k].Domain == domain) && (Ha.Data.Modules[k].Address == address)) {
                        var module1 = Ha.Data.Modules[k];
                        // napolni glede na widget

                        if ((module1.DeviceType == 'S_GENERIC') ||
                        (module1.DeviceType == 'S_DOOR') ||
                        (module1.DeviceType == 'S_MOTION') ||
                        (module1.DeviceType == 'S_LEAK') ||
                        (module1.DeviceType == 'S_DIGITAL_INPUT') ||
                        (module1.DeviceType == 'S_TEMP') ||
                        (module1.DeviceType == 'S_BARO') ||
                        (module1.DeviceType == 'S_ANALOG_INPUT') ||
                        (module1.DeviceType == 'S_HUM') ||
                        (module1.DeviceType == 'S_LIGHT_LEVEL') ||
                        (module1.DeviceType == 'S_DISTANCE') ||
                        (module1.DeviceType == 'S_DUST') ||
                        (module1.DeviceType == 'S_POWER') ||
                        (module1.DeviceType == 'S_WATER') ||
                        (module1.DeviceType == 'S_UV')) {
                            container = $('#groupdiv_' + i + '_' + module1.Domain + '_' + module1.Address);
                            widget = container.find('[data-ui-field=widget]');

                            if (widget != null && widget != 'undefined') {
                                widget.find('[data-ui-field=name]').html(module1.Description);
                                widget.find('[data-ui-field=description]').html(module1.Domain + ' ' + module1.Address);

                                updatetime = null;
                                data = Ha.WebApp.Control.GetWidgetUIData(module1);

                                updatetime = data.timestamp;
                                widget.find('[data-ui-field=status]').html(data.status);
                                widget.find('[data-ui-field=icon]').attr('src', data.icon);
                                // battery
                                widget.find('[data-ui-field=sensorstatus]').html(Ha.WebApp.Control.GetWidgetBatteryData(module1));

                                // update time
                                widget.find('[data-ui-field=updatetime]').html(Ha.WebApp.Control.GetWidgetDateTime(updatetime));
                            }
                        }
                        else if (module1.DeviceType == 'S_DIGITAL_OUTPUT') {
                            container = $('#groupdiv_' + i + '_' + module1.Domain + '_' + module1.Address);
                            widget = container.find('[data-ui-field=widget]');

                            if (widget != null && widget != 'undefined') {
                                var controlpopup = widget.data('ControlPopUp')
                                if (!controlpopup) {
                                    container.find('[data-ui-field=controlpopup]').trigger('create');
                                    controlpopup = container.find('[data-ui-field=controlpopup]').popup();
                                    widget.data('ControlPopUp', controlpopup);

                                    controlpopup.find('[data-ui-field=command_on]').on('click', function () {
                                        Ha.Data.ServiceCall('Control/Module/' + module1.Domain + '/' + module1.Address + '/ControlOn/', null, "POST", null);
                                    });

                                    controlpopup.find('[data-ui-field=command_off]').on('click', function () {
                                        Ha.Data.ServiceCall('Control/Module/' + module1.Domain + '/' + module1.Address + '/ControlOff/', null, "POST", null);
                                    });

                                    widget.on('click', function () {
                                        if ($(container).find('[data-ui-field=widget]').data('ControlPopUp')) {
                                            $(container).find('[data-ui-field=widget]').data('ControlPopUp').popup('open');
                                        }
                                    });
                                }
                                controlpopup.find('[data-ui-field=group]').html(group.GroupName);

                                updatetime = null;
                                data = Ha.WebApp.Control.GetWidgetUIData(module1);
                                updatetime = data.timestamp;
                                widget.find('[data-ui-field=status]').html(data.status);
                                widget.find('[data-ui-field=icon]').attr('src', data.icon);

                                widget.find('[data-ui-field=name]').html(module1.Description);
                                widget.find('[data-ui-field=description]').html(module1.Domain + ' ' + module1.Address);

                                // battery
                                widget.find('[data-ui-field=sensorstatus]').html(Ha.WebApp.Control.GetWidgetBatteryData(module1));
                                // update time
                                widget.find('[data-ui-field=updatetime]').html(Ha.WebApp.Control.GetWidgetDateTime(updatetime));
                                // update popup
                                controlpopup.find('[data-ui-field=icon]').attr('src', data.icon);
                                controlpopup.find('[data-ui-field=group]').html(group.GroupName);
                                controlpopup.find('[data-ui-field=name]').html(module1.Description);
                                controlpopup.find('[data-ui-field=status]').html(data.status);
                            }
                        }
                        else if ((module1.DeviceType == 'S_ANALOG_OUTPUT') ||
                            (module1.DeviceType == 'S_TEMP_AO') ||
                            (module1.DeviceType == 'S_HUM_AO') ||
                            (module1.DeviceType == 'S_DIMMER')) {
                            container = $('#groupdiv_' + i + '_' + module1.Domain + '_' + module1.Address);
                            widget = container.find('[data-ui-field=widget]');

                            if (widget != null && widget != 'undefined') {
                                var controlpopup = widget.data('ControlPopUp')
                                if (!controlpopup) {
                                    container.find('[data-ui-field=controlpopup]').trigger('create');

                                    controlpopup = container.find('[data-ui-field=controlpopup]').popup();
                                    widget.data('ControlPopUp', controlpopup);



                                    if ((module1.DeviceType == 'S_DIMMER')) {
                                        controlpopup.find('[data-ui-field=command_on]').on('click', function () {
                                            Ha.Data.ServiceCall('Control/Module/' + module1.Domain + '/' + module1.Address + '/ControlOn/', null, "POST", null);
                                        });

                                        controlpopup.find('[data-ui-field=command_off]').on('click', function () {
                                            Ha.Data.ServiceCall('Control/Module/' + module1.Domain + '/' + module1.Address + '/ControlOff/', null, "POST", null);
                                        });
                                    }

                                    // knob
                                    widget.on('click', function () {
                                        if ($(container).find('[data-ui-field=widget]').data('ControlPopUp')) {

                                            var o1 = Ha.WebApp.Utility.GetModulePropertyByName(module1, "Settings.MinValue");
                                            if (o1 == null)
                                                knobMinValue = 0;
                                            else {
                                                knobMinValue = Math.round(o1.Value.replace(',', '.') * 100) / 100;
                                                if (isNaN(knobMinValue)) knobMinValue = o1.Value;
                                            }

                                            var o2 = Ha.WebApp.Utility.GetModulePropertyByName(module1, "Settings.MaxValue");
                                            if (o2 == null)
                                                knobMaxValue = 100;
                                            else {
                                                knobMaxValue = Math.round(o2.Value.replace(',', '.') * 100) / 100;
                                                if (isNaN(knobMaxValue)) knobMaxValue = o2.Value;
                                            }

                                            var o3 = Ha.WebApp.Utility.GetModulePropertyByName(module1, "Settings.ValueStep");
                                            if (o3 == null)
                                                knobValueStep = 1;
                                            else {
                                                knobValueStep = Math.round(o3.Value.replace(',', '.') * 100) / 100;
                                                if (isNaN(knobValueStep)) knobValueStep = o3.Value;
                                            }


                                            //Ha.WebApp.Control.UpdateModuleWidgetKnobValue(controlpopup, module1);


                                            controlpopup.find('[data-ui-field=level_knob]').knob({
                                                'release': function (v) {
                                                    v = Math.round(v * 100) / 100;
                                                    //Ha.Data.ServiceCall('Control/Module/' + module1.Domain + '/' + module1.Address + '/ControlLevel/' + v, null, "POST", null);
                                                }
                                                //                                                ,
                                                //                                                'change': function (v) {
                                                //                                                    v = Math.round(v * 100) / 100;
                                                //                                                }
                                            });


                                            //                                            controlpopup.find('[data-ui-field=level_knob]').knob({
                                            //                                                'release': function (v) {
                                            //                                                    v = Math.round(v * 100) / 100;
                                            //                                                    Ha.Data.ServiceCall('Control/Module/' + module1.Domain + '/' + module1.Address + '/ControlLevel/' + v, null, "POST", null);
                                            //                                                },
                                            ////                                                'change': function (v) {
                                            ////                                                    //v = Math.round(v);
                                            ////                                                    //controlpopup.find('[data-ui-field=status]').html(v + '%');
                                            ////                                                }
                                            //                                            });

                                            controlpopup.find('[data-ui-field=level_knob]').knob({
                                                'min': knobMinValue,
                                                'max': knobMaxValue,
                                                'step': knobValueStep
                                            });

                                            //controlpopup.find('[data-ui-field=level_knob]').val(knobValue);

                                            //Ha.WebApp.Control.UpdateModuleWidgetKnobValue(controlpopup, module1);

                                            controlpopup.find('[data-ui-field=level_knob]').trigger(
                                                'configure',
                                                {
                                                    'min': knobMinValue,
                                                    'max': knobMaxValue,
                                                    'step': knobValueStep
                                                });

                                            Ha.WebApp.Control.UpdateModuleWidgetKnobValue(controlpopup, module1);
                                            $(container).find('[data-ui-field=widget]').data('ControlPopUp').popup('open');
                                        }
                                    });
                                }
                                controlpopup.find('[data-ui-field=group]').html(group.GroupName);
                                //Ha.WebApp.Control.UpdateModuleWidgetKnobValue(controlpopup, module1);

                                updatetime = null;

                                data = Ha.WebApp.Control.GetWidgetUIData(module1);
                                updatetime = data.timestamp;
                                widget.find('[data-ui-field=status]').html(data.status);
                                widget.find('[data-ui-field=icon]').attr('src', data.icon);

                                widget.find('[data-ui-field=name]').html(module1.Description);
                                widget.find('[data-ui-field=description]').html(module1.Domain + ' ' + module1.Address);

                                // battery
                                widget.find('[data-ui-field=sensorstatus]').html(Ha.WebApp.Control.GetWidgetBatteryData(module1));
                                // update time
                                widget.find('[data-ui-field=updatetime]').html(Ha.WebApp.Control.GetWidgetDateTime(updatetime));
                                // update popup
                                //                                controlpopup.find('[data-ui-field=icon]').attr('src', data.icon);
                                //                                controlpopup.find('[data-ui-field=group]').html(group.GroupName);
                                controlpopup.find('[data-ui-field=name]').html(module1.Description);
                                //                                controlpopup.find('[data-ui-field=status]').html(data.status);
                                controlpopup.find('[data-ui-field=unit]').html(data.unit);



                                var knobValue = Math.round(data.rawvalue.replace(',', '.') * 100) / 100;
                                if (isNaN(knobValue)) knobValue = data.rawvalue;

                                controlpopup.find('[data-ui-field=level_knob]').unbind('slidestop');
                                controlpopup.find('[data-ui-field=level_knob]').unbind('release');
                                //controlpopup.find('[data-ui-field=level_knob]').unbind('release');
                                //controlpopup.find('[data-ui-field=level_knob]').knob({ 'release': function (v) { } });
                                //                                controlpopup.find('[data-ui-field=level_knob]').val(knobValue).trigger('change');
                                controlpopup.find('[data-ui-field=level_knob]').val(knobValue);

//                                setTimeout(function () {
//                                    controlpopup.find('[data-ui-field=level_knob]').knob({
//                                        'release': function (v) {
//                                            v = Math.round(v * 100) / 100;
//                                            Ha.Data.ServiceCall('Control/Module/' + module1.Domain + '/' + module1.Address + '/ControlLevel/' + v, null, "POST", null);
//                                        }
//                                    });
//                                }, 1000);
//                                                             
                                controlpopup.find('[data-ui-field=level_knob]').knob({
                                    'release': function (v) {
                                        v = Math.round(v * 100) / 100;
                                        Ha.Data.ServiceCall('Control/Module/' + module1.Domain + '/' + module1.Address + '/ControlLevel/' + v, null, "POST", null);
                                    }
                                });
                            }
                        }
                    }
                }
            }
        }
    }
}


Ha.WebApp.Control.SendEventToUi = function (module, event) {
    if (module != null) {
        Ha.WebApp.Control.UpdateModuleWidget(event.Domain, event.Address);
    }
}


Ha.WebApp.Control.RenderGroups = function () {
    var group = null;

    $('#control_groupslist').empty();

    for (var i = 0; i < Ha.Data.Groups.length; i++) {
        group = Ha.Data.Groups[i];
        var el = '<div id=groupdiv_' + i + ' class="ui-collapsible" data-role="collapsible"><h3>' + group.GroupName + '</h3><ul data-role="listview">';
        for (var j = 0; j < group.Modules.length; j++) {
            var module = group.Modules[j];
            for (var k = 0; k < Ha.Data.Modules.length; k++) {
                if ((Ha.Data.Modules[k].Domain == module.Domain) && (Ha.Data.Modules[k].Address == module.Address)) {
                    //el += '<li><a href="#">' + module.Address + '</a></li>';

                    var module1 = Ha.Data.Modules[k];
                    // napolni glede na widget

                    if ((module1.DeviceType == 'S_GENERIC') ||
                    (module1.DeviceType == 'S_DIGITAL_INPUT') ||
                    (module1.DeviceType == 'S_BARO') ||
                    (module1.DeviceType == 'S_ANALOG_INPUT') ||
                    (module1.DeviceType == 'S_HUM') ||
                    (module1.DeviceType == 'S_TEMP') ||
                    (module1.DeviceType == 'S_LEAK') ||
                    (module1.DeviceType == 'S_DOOR') ||
                    (module1.DeviceType == 'S_MOTION') ||
                    (module1.DeviceType == 'S_LIGHT_LEVEL') ||                    
                    (module1.DeviceType == 'S_DISTANCE') ||
                    (module1.DeviceType == 'S_DUST') ||
                    (module1.DeviceType == 'S_POWER') ||
                    (module1.DeviceType == 'S_WATER') ||
                    (module1.DeviceType == 'S_UV')) {
                        // Door
                        el += '<li data-module-index="' + k + '" id=groupdiv_' + i + '_' + module1.Domain + '_' + module1.Address + '><a data-ui-field="widget">';
                        el += '<img data-ui-field="icon" style="margin-left: 10px; margin-top: 10px" width="42"';
                        el += 'src="images/widgets/sensor.png" />';
                        el += '<span data-ui-field="name">loading...</span>';
                        el += '<br />';
                        el += '<p style="margin: 0">';
                        el += '<span data-ui-field="description" style="color: gray">description loading...</span><br />';
                        el += '<div data-ui-field="status" style="font-family: Monospace; font-size: 12pt; color: green">';
                        //el += 'status';
                        el += '</div>';
                        el += '<div data-ui-field="sensorstatus" style="font-family: Monospace; font-size: 10pt;';
                        el += 'color: green; text-wrapping: wrap; margin-top: 5px; padding-bottom: 5px;">';
                        //el += 'sensorstatus';
                        el += '</div>';
                        el += '<div data-ui-field="updatetime" style="position: absolute; right: 50px; top: 32%;';
                        el += 'bottom: 67%; color: gray; font-size: 8pt; font-weight: normal; text-align: right">';
                        //el += 'update date<br>';
                        //el += 'update time';
                        el += '</div>';
                        el += '</p>';
                        el += '</a><a href="#page_control_chart">Chart</a></li>';
                    }
                    else if (module1.DeviceType == 'S_DIGITAL_OUTPUT') {
                        // Light
                        el += '<li data-module-index="' + k + '" id=groupdiv_' + i + '_' + module1.Domain + '_' + module1.Address + ' ><a data-ui-field="widget">';
                        el += '<img data-ui-field="icon" style="margin-left: 10px; margin-top: 10px" width="42"';
                        el += 'src="images/widgets/socket_off.png" />';
                        el += '<span data-ui-field="name">loading...</span>';
                        el += '<br />';
                        el += '<p style="margin: 0">';
                        el += '<span data-ui-field="description" style="color: gray">description loading...</span><br />';
                        el += '<div data-ui-field="status" style="font-family: Monospace; font-size: 12pt; color: green">';
                        //el += 'status';
                        el += '</div>';
                        el += '<div data-ui-field="sensorstatus" style="font-family: Monospace; font-size: 10pt;';
                        el += 'color: green; text-wrapping: wrap; margin-top: 5px; padding-bottom: 5px;">';
                        //el += 'sensorstatus';
                        el += '</div>';
                        el += '<div data-ui-field="updatetime" style="position: absolute; right: 50px; top: 32%;';
                        el += 'bottom: 67%; color: gray; font-size: 8pt; font-weight: normal; text-align: right">';
                        //el += 'update date<br>';
                        //el += 'update time';
                        el += '</div>';
                        el += '</p>';
                        el += '</a><a href="#page_control_chart">Chart</a>';

                        el += '<!-- Popup --->';
                        el += '<div data-ui-field="controlpopup" data-position-to="window" style="width:260px" data-transition="pop" >';
                        el += '<a href="#" data-rel="back" data-role="button" data-icon="delete" data-iconpos="notext" class="ui-btn-right">Close</a>';

                        el += '<div style="margin:10px">';

                        el += '<table width="100%">';
                        el += '<tr>';
                        el += '<td width="64">';
                        el += '<img data-ui-field="icon" height="64" src="images/widgets/socket_off.png" />';
                        el += '</td>';
                        el += '<td>';
                        el += '<div data-ui-field="group" style="margin:0;font-family:Georgia;font-size:11pt;color:gray">Group Name</div>';
                        el += '<h4 data-ui-field="name" style="margin:0;">Description</h4>';
                        el += '</td>';
                        el += '</tr>';
                        el += '</table>';
                        el += '<div data-ui-field="status" style="margin:0;font-size:18pt;" align="center"></div>';
                        el += '<div align="center">';
                        el += '<div data-role="controlgroup" data-type="horizontal">';
                        el += '<a data-role="button" data-ui-field="command_off">OFF</a>';
                        el += '<a data-role="button" data-ui-field="command_on">ON</a>';
                        el += '</div>';
                        el += '</div>';
                        el += '<br />';
                        el += '</div>';
                        el += '</div>';

                        el += '</li>';
                    }
                    else if ((module1.DeviceType == 'S_ANALOG_OUTPUT') ||
                        (module1.DeviceType == 'S_TEMP_AO') ||
                        (module1.DeviceType == 'S_HUM_AO') ||
                        (module1.DeviceType == 'S_DIMMER') )
                         {
                        // analog output
                        el += '<li data-module-index="' + k + '" id=groupdiv_' + i + '_' + module1.Domain + '_' + module1.Address + ' ><a data-ui-field="widget">';
                        el += '<img data-ui-field="icon" style="margin-left: 10px; margin-top: 10px" width="42"';
                        el += 'src="images/widgets/ao.png" />';
                        el += '<span data-ui-field="name">loading...</span>';
                        el += '<br />';
                        el += '<p style="margin: 0">';
                        el += '<span data-ui-field="description" style="color: gray">description loading...</span><br />';
                        el += '<div data-ui-field="status" style="font-family: Monospace; font-size: 12pt; color: green">';
                        //el += 'status';
                        el += '</div>';
                        el += '<div data-ui-field="sensorstatus" style="font-family: Monospace; font-size: 10pt;';
                        el += 'color: green; text-wrapping: wrap; margin-top: 5px; padding-bottom: 5px;">';
                        //el += 'sensorstatus';
                        el += '</div>';
                        el += '<div data-ui-field="updatetime" style="position: absolute; right: 50px; top: 32%;';
                        el += 'bottom: 67%; color: gray; font-size: 8pt; font-weight: normal; text-align: right">';
                        //el += 'update date<br>';
                        //el += 'update time';
                        el += '</div>';
                        el += '</p>';
                        el += '</a><a href="#page_control_chart">Chart</a>';

                        el += '<!-- Popup --->';
                        el += '<div data-ui-field="controlpopup" data-position-to="window" style="width:260px" data-transition="pop" >';
                        el += '<a href="#" data-rel="back" data-role="button" data-icon="delete" data-iconpos="notext" class="ui-btn-right">Close</a>';


                        el += '<div style="margin:10px">';
                        el += '<table width="100%">';
                        el += '<tr><td>';
                        el += '<div data-ui-field="group" style="margin:0;font-family:Georgia;font-size:11pt;color:gray">Group Name</div>';
                        el += '<h4 data-ui-field="name" style="margin:0;">Description</h4>';
                        el += '</td>';
                        el += '</tr>';
                        el += '<tr><td>';
                        el += '<div align="center">';
                        el += '<h1 data-ui-field="unit" style="margin:0;"></h1>';
                        el += '</div>';
                        el += '</td></tr>';
                        el += '</table>';
                        el += '<div data-ui-field="status" style="margin:0;font-size:18pt;" align="center"></div>';
                        el += '<div align="center">';
                        el += '<input data-ui-field="level_knob" data-role="none" type="text" class="dial" ';
                        el += 'data-angleOffset="-125" data-angleArc="250" data-displayprevious=true>';
                        
                        el += '</div>';
                        
                        if (module1.DeviceType == 'S_DIMMER')
                        {
                            el += '<div data-ui-field="status" style="margin:0;font-size:18pt;" align="center"></div>';
                            el += '<div align="center">';
                            el += '<div data-role="controlgroup" data-type="horizontal">';
                            el += '<a data-role="button" data-ui-field="command_off">OFF</a>';
                            el += '<a data-role="button" data-ui-field="command_on">ON</a>';
                            el += '</div>';
                            el += '</div>';                            
                        }

                        el += '<br/>';
                        el += '</div>';
                        el += '</div>';

                        el += '</li>';
                    }
                }
            }
        }
        el += '</ul></div>';
        $('#control_groupslist').append(el);

        $("#control_groupslist li").on("click", function () {
            var midx = $(this).attr('data-module-index');

            var m = Ha.Data.Modules[midx];

            if (m != null) {
                $("#control_groupslist").attr('selected-domain', m.Domain);
                $("#control_groupslist").attr('selected-address', m.Address);
            }
        });

    }

    for (var l = 0; l < Ha.Data.Modules.length; l++) {
        module1 = Ha.Data.Modules[l];
        Ha.WebApp.Control.UpdateModuleWidget(module1.Domain, module1.Address);
    }

    $('#control_groupslist').collapsibleset().trigger('create');
}


// init control page
Ha.WebApp.Control.ReloadPage = function () {
    //1. load modules
    Ha.Data.ServiceCall("Config/Module/List/", null, "GET", function (data) {
        Ha.Data.Modules = data.Modules;
        // 2. load groups
        Ha.Data.ServiceCall("Config/Group/List", null, "GET", function (data) {
            Ha.Data.Groups = data.Groups;
            // 3. render groups
            Ha.WebApp.Control.RenderGroups();
        });
    });

    // change password
    $("#change_password_button").unbind("click");
    $('#change_password_button').on('click', function (event) {
        Ha.Data.ServiceCall("Config/Webinterface/ChangePassword/", $("#change_password").val(), "POST", function (data) {
            if (data == '1') {
                $("#change_password").val("");
            }
        });
    })

}

Ha.WebApp.Control.LogOff = function () {
    Ha.WebApp.Events.es.close();
    //1. load modules
    try {
        Ha.Data.ServiceCall("Config/Webinterface/LogOff/", null, "POST", function (data) {
        }, false);
    }
    catch (err) {
    }
    //window.location.href = "about:blaSnk";
    setTimeout(function () { window.location.href = "about:blank"; }, 1000);
}

Ha.WebApp.Control.OpenConfig = function () {
    Ha.Data.ServiceCall("Config/Webinterface/IsAdmin/", null, "GET", function (data) {
        if (data == '1')
            window.open("#page_config", "_parent");
        else
            alert('You are not authorized to see this page!')
    });    
}



Ha.WebApp.Control.ChartDisplayData = function (data) {
    var options = {
        xaxis: {
            mode: "time",
            timezone: "browser"
        },
        //        points: {
        //            show: true
        //        },
        lines: { show: true, steps: true },
        selection: {
            mode: "x"
        }
//        grid: {
//            hoverable: true,
//            clickable: true
//        },
//        series: {
//            points: {
//                show: true
//            }
//        }

    };

    var plot = $.plot("#placeholder", data, options);

//    var overview = $.plot("#overview", data, {
//        series: {
//            lines: {
//                show: true,
//                steps: true,
//                lineWidth: 1
//            },
//            shadowSize: 0
//        },
//        xaxis: {
//            ticks: [],
//            mode: "time",
//            timezone: "browser"
//        },
//        yaxis: {
//            ticks: [],
//            min: 0,
//            autoscaleMargin: 0.1
//        },
//        selection: {
//            mode: "x"
//        }
//    });

    $("#placeholder").unbind("plotselected");
    $("#placeholder").bind("plotselected", function (event, ranges) {

        // do the zooming
        $.each(plot.getXAxes(), function (_, axis) {
            var opts = axis.options;
            opts.min = ranges.xaxis.from;
            opts.max = ranges.xaxis.to;
        });
        plot.setupGrid();
        plot.draw();
        plot.clearSelection();

        // don't fire event on the overview to prevent eternal loop

        //overview.setSelection(ranges, true);
    });

//    $("#overview").unbind("plotselected");
//    $("#overview").bind("plotselected", function (event, ranges) {
//        plot.setSelection(ranges);
//    });

    $(".chart1").resizable({
        maxWidth: 900,
        maxHeight: 500,
        minWidth: 450,
        minHeight: 250
    });

//    $(".chart2").resizable({
//        maxWidth: 900,
//        maxHeight: 150,
//        minWidth: 450,
//        minHeight: 100
//    });
}

Ha.WebApp.Control.ChartSetYAxis = function () {
    var yaxis = 1;

    for (var h = 0; h < Ha.WebApp.Control.Dataset.length; h++) {
        var ds = Ha.WebApp.Control.Dataset[h];
        ds.yaxis = yaxis;
        yaxis = yaxis + 1;
    }
}

Ha.WebApp.Control.ChartLoadData = function () {

    //var mode = $('#radio-chart-horizont').val();
    var mode = $('input[name="radio-chart-horizont"]:checked').val();

    // check if data already exists
    for (var k = 0; k < Ha.Data.Modules.length; k++) {
        var m = Ha.Data.Modules[k];
        for (var j = 0; j < m.Properties.length; j++) {
            var p = m.Properties[j];

            if ($('#cbx_chart_' + k + '_' + j).is(":checked")) {
                // dodajamo
                var found = false;
                for (var h = 0; h < Ha.WebApp.Control.Dataset.length; h++) {
                    var ds = Ha.WebApp.Control.Dataset[h];

                    if (ds.domain == m.Domain && ds.address == m.Address && ds.property == p.Name && ds.mode == mode)
                        found = true;
                }

                if (!found) {
                    Ha.Data.ServiceCall('Control/Data/' + m.Domain + '/' + m.Address + '/' + p.Name + '/' + mode, null, "GET", function (dataset) {
                        Ha.WebApp.Control.Dataset.push(dataset);
                        Ha.WebApp.Control.ChartSetYAxis();
                        Ha.WebApp.Control.ChartDisplayData(Ha.WebApp.Control.Dataset);
                    });
                }
            }
            else {
                // brisemo;
                for (var h = 0; h < Ha.WebApp.Control.Dataset.length; h++) {
                    var ds = Ha.WebApp.Control.Dataset[h];

                    if (ds.domain == m.Domain && ds.address == m.Address && ds.property == p.Name && ds.mode == mode) {
                        Ha.WebApp.Control.Dataset.splice(h, 1);
                        Ha.WebApp.Control.ChartSetYAxis();
                        Ha.WebApp.Control.ChartDisplayData(Ha.WebApp.Control.Dataset);
                    }
                }
            }
        }
    }
}

Ha.WebApp.Control.ChartHorizontChanged = function () {
    // clear array
    Ha.WebApp.Control.Dataset = Array();
    Ha.WebApp.Control.ChartDisplayData(Ha.WebApp.Control.Dataset);
    Ha.WebApp.Control.ChartLoadData();
}


// init control page
Ha.WebApp.Control.InitChart = function () {
    $('#radio-choice-chart-2a').prop('checked', 'checked');
    $("#radio-choice-chart-2a").checkboxradio('refresh');
    $("#radio-choice-chart-2b").checkboxradio('refresh');
    $("#radio-choice-chart-2c").checkboxradio('refresh');
    $("#radio-choice-chart-2d").checkboxradio('refresh');


    //1. load modules
    Ha.Data.ServiceCall("Config/Module/List/", null, "GET", function (data) {
        Ha.Data.Modules = data.Modules;

        var domain = $("#control_groupslist").attr('selected-domain');
        var address = $("#control_groupslist").attr('selected-address');

        Ha.WebApp.Configure.SelectedModule = Ha.Data.Module.GetModuleByDomainAddress(domain, address);


        $('#chart_parameters').empty();

        // create chekboxes
        for (var k = 0; k < Ha.Data.Modules.length; k++) {
            var m = Ha.Data.Modules[k];

            var el = '';

            var found = false;
            for (var j = 0; j < m.Properties.length; j++) {
                var p = m.Properties[j];
                if ((p.LogToDatabase == 'true') || (p.LogToDatabase == 'True'))
                    found = true;
            }

            if (found) {
                el += '<div id="module-id"=' + k + '>';
                el += '<fieldset data-role="controlgroup">';
                el += '<legend><b>' + m.Description + '</b> <span style="color: gray">' + m.Domain + ' ' + m.Address + '</span></legend>';

                for (var j = 0; j < m.Properties.length; j++) {
                    var p = m.Properties[j];

                    if ((p.LogToDatabase == 'true') || (p.LogToDatabase == 'True')) {
                        el += '<input type="checkbox" id="cbx_chart_' + k + '_' + j + '" ';

                        if (m.Address == address && m.Domain == domain)
                            el += 'checked="checked"';
                        el += ' onchange="javascript:Ha.WebApp.Control.ChartLoadData();">';
                        //el += '<label for="cbx_chart_' + k + '_' + j + '">' + p.Name + p.Description + '</label>';

                        if (p.Description != '')
                            el += '<label for="cbx_chart_' + k + '_' + j + '">' + p.Description; // + '</label>';
                        else
                            el += '<label for="cbx_chart_' + k + '_' + j + '">' + p.Name; // +'</label>';

                        if (p.Unit != '')
                            el += ' (' + p.Unit + ')';

                        el += '</label>';
                    }
                }
                el += '</fieldset>';
                el += '</div>';
                $('#chart_parameters').append(el);
            }
        }

        $('#chart_parameters').trigger('create');

        // clear array
        Ha.WebApp.Control.Dataset = Array();
        Ha.WebApp.Control.ChartDisplayData(Ha.WebApp.Control.Dataset);

        Ha.WebApp.Control.ChartLoadData();
    });

}